#ifndef H_SPARSELIST
#define H_SPARSELIST

#include <vector>

template <typename T>
class SparseList {
public:
    SparseList()
    { }

    ~SparseList()
    { }

    void set(size_t index, const T& value)
    {
        printf("set(%zu) -begin\n", index);
        // find first header with start less than index
        size_t data_index = 0;
        size_t header_index = 0;
        for(; header_index < m_headers.size() && m_headers[header_index].start > index; ++header_index) {
            data_index += m_headers[header_index].length;
        }

        // if no header exists, add header starting at index
        if(header_index == m_headers.size()) {
            Header header {0};
            header.start = index;
            header.length = 1;
            header.index = m_data.size();
            m_data.push_back(value);
        }
        // otherwise, update/append existing or insert new header
        else {
            size_t offset = index - m_headers[header_index].start;

            if(offset < m_headers[header_index].length) {
                // update existing item
                size_t data_index = m_headers[header_index].index + offset;
                m_data[data_index] = value;
            }
            else if(offset == m_headers[header_index].length) {
                // append value to header
                m_headers[header_index].length++;
                m_data.insert(m_data.begin() + (m_headers[header_index].index + offset), value);

                // combine headers if intersection is created
                if(header_index + 1 != m_headers.size()) {
                    if(m_headers[header_index + 1].start == m_headers[header_index].start + m_headers[header_index].length) {
                        m_headers[header_index].length += m_headers[header_index + 1].length;
                        m_headers.erase(m_headers.begin() + (header_index + 1));
                    }
                }
            }
            else {
                // insert new header after current
                Header header {0};
                header.start = index;
                header.length = 1;
                header.index = m_headers[header_index].index + 1;
                m_data.insert(m_data.begin() + header.index, value);
            }
        }
        printf("set() -end\n");
    }

    void unset(size_t index)
    {
        // find first header with start less than index
        size_t header_index = 0;
        for(; header_index < m_headers.size() && m_headers[header_index].start > index; ++header_index) { }

        if(header_index < m_headers.size()) {
            auto& header = m_headers[header_index];
            size_t offset = index - header.start;

            if(offset < header.length) {
                // remove value from data

            }
        }
    }

    T& get(size_t index)
    {
        size_t bound_lower = 0;
        size_t bound_upper = m_headers.size();
        size_t header_index = bound_lower + ((bound_upper - bound_lower) / 2);

        while(bound_lower != bound_upper) {

        }
    }

private:
    struct Header {
        size_t start;
        size_t length;
        size_t index;
    };

    size_t m_root;
    std::vector<Header> m_headers;
    std::vector<T> m_data;
};

#endif
